﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿/*
 *===================================File description=============================================
 * File Name    : common_adv.js
 * Comment      : adv관련  Function
 * Create Date  : 2009/12/09
 * Author       : PBH
 *================================================================================================




>>> Validation
-------------------------------------------------------------------------------------------------
 - gfn_adv_chkEmail            : 이메일 유효성검증 
 - gfn_adv_getRegExpReturn     : RegExp의 return 값 반환
 - gfn_adv_chkVenderRegNo      : 법인등록번호 체크
 - gfn_adv_IsNumber            : 문자열이 숫자로만 되어있는지 판단하는 함수 
 - gfn_adv_chkJuminNo          : 주민등록번호 적함성 여부 체크 13자리
 - gfn_adv_chkJuminNo2         : 주민등록번호 적함성 여부 체크 6자,7자 분리체크
 - gfn_adv_chkForeignerJuminNo : 외국인등록번호 형식 check
 - gfn_adv_chkGridNull_Full    : 그리드 저장시 필수항목 Null check(Normal 상태 포함) 
 - gfn_adv_removeSortMark      : Grid Sort Mark 제거
 

 
 
>>> Etc.
-------------------------------------------------------------------------------------------------
 - gfn_adv_debug               : 해당 데이터셑의 내용을 상세히 보여준다.  
 
 
*/
//sort
var jv_sASC_MARK  = "▲";
var jv_sDESC_MARK = "▼";

/*------------------------------------------------------------------------------
* 기   능:	이메일 유효성 검증
* 인   수:  sEmailAddress
* Return :  boolean
------------------------------------------------------------------------------*/
function gfn_adv_chkEmail(sEmailAddress)
{
	var sRegExp = "[a-z0-9]([-_.]?[a-z0-9])+@[a-z0-9]([-_.]?[a-z0-9])+\\.[a-z0-9]{2,3}";
	return gfn_adv_getRegExpReturn(sRegExp, "ig", sEmailAddress);
}


/*------------------------------------------------------------------------------
* 기   능:	RegExp의 return 값 반환
* 인   수:  sPattern   (검색패턴)
            sOption    (검색에 적용할 옵션)
            sSource    (검색할 대상 문자열)
* Return :  boolean
------------------------------------------------------------------------------*/
function gfn_adv_getRegExpReturn(sPattern, sOption, sSource)
{
	var bReturnValue = false;
	var regexp = CreateRegExp(sPattern, sOption);
	sTmp = regexp.Exec(sSource);
	
	if ( sTmp == null ) {
			bReturnValue = false;
	} else {
		if ( ( sTmp.index == 0 ) && (sTmp.length == sSource.length ) ) {
			bReturnValue = true;
			
		} else {
			bReturnValue = false;
		}	
	}

	return bReturnValue;
}


/*------------------------------------------------------------------------------
* 기   능:	법인등록번호 체크
* 인   수:  sRegNo (법인등록번호)
* Return :  boolean
------------------------------------------------------------------------------*/
function gfn_adv_chkVenderRegNo( sRegNo )
{
	var temp;

	if( length(sRegNo) != 10 )
	{
		return false;
	}
	if( gfn_adv_IsNumber( sRegNo ) == false )
	{
		return false;
	}
	temp = ToInteger(ToInteger(sRegNo[8])*5/10);
	if( ToInteger(sRegNo[9]) !=
		(( 10 - (((ToInteger(sRegNo[0])*1)%10 ) +
				((ToInteger(sRegNo[1])*3)%10 ) +
				((ToInteger(sRegNo[2])*7)%10 ) +
				((ToInteger(sRegNo[3])*1)%10 ) +
				((ToInteger(sRegNo[4])*3)%10 ) +
				((ToInteger(sRegNo[5])*7)%10 ) +
				((ToInteger(sRegNo[6])*1)%10 ) +
				((ToInteger(sRegNo[7])*3)%10 ) +
				temp +
				((ToInteger(sRegNo[8])*5)%10 ))%10)%10) )
	{
		return false;
	}

	return true;
}


/***************************************************************
* 기   능:	문자열이 숫자로만 되어있는지 판단하는 함수
* 인   수:  str (입력값)
* Return :  boolean			
****************************************************************/
function gfn_adv_IsNumber(str)
{
	var		i;
	var		len;
	var		c;
	
	len = Length(str);
	for( i = 0 ; i < len ; i++ )
	{
		c = str[i];
		if( ( i == 0 && c == '-' ) ||
			( c >= '0' && c <= '9' ) );
		else
			return false;
	}
	return true;
}



/*------------------------------------------------------------------------------
* 기   능:	주민등록번호 적함성 여부 체크
* 인   수:  sJuminNo (주민번호앞13자리)
* Return :  boolean
------------------------------------------------------------------------------*/
function gfn_adv_chkJuminNo( sJuminNo ) {
	if(trim(sJuminNo).length != 13) return false;

	var sFrontNo = substr(sJuminNo, 0 , 6);
	var sTailNo  = substr(sJuminNo, 6 , 7);
	return gfn_adv_chkJuminNo2( sFrontNo, sTailNo );
}

/*------------------------------------------------------------------------------
* 기   능:	주민등록번호 적함성 여부 체크
* 인   수:  sFrontNo (주민번호앞6자리)
            sTailNo  (주민번호뒤7자리) 
* Return :  boolean
------------------------------------------------------------------------------*/
function gfn_adv_chkJuminNo2( sFrontNo, sTailNo ) {
	var tmp1, tmp2, tmp3;
	var t1, t2, t3, t4, t5, t6, t7;
	
	tmp1 = sFrontNo.substr( 2, 2 );
	tmp2 = sFrontNo.substr( 4 );
    tmp3 = sTailNo.substr( 0, 1 );
           
	if(sFrontNo.length != 6) return false;
	if(sTailNo.length != 7 ) return false;
	if ( (tmp1 < "01") || (tmp1 > "12") ) return false;
	if ( (tmp2 < "01") || (tmp2 > "31") ) return false;
	if ( (tmp3 < "1" ) || (tmp3 > "4" ) ) return false;

	t1  = sFrontNo.substr( 0, 1 );
	t2  = sFrontNo.substr( 1, 1 );
	t3  = sFrontNo.substr( 2, 1 );
	t4  = sFrontNo.substr( 3, 1 );
	t5  = sFrontNo.substr( 4, 1 );
	t6  = sFrontNo.substr( 5, 1 );
	t11 = sTailNo.substr( 0, 1 );
	t12 = sTailNo.substr( 1, 1 );
	t13 = sTailNo.substr( 2, 1 );
	t14 = sTailNo.substr( 3, 1 );
	t15 = sTailNo.substr( 4, 1 );
	t16 = sTailNo.substr( 5, 1 );
	t17 = sTailNo.substr( 6, 1 );
	
	var tot  = tointeger(t1)  * 2 + tointeger(t2)  * 3 + tointeger(t3)  * 4 + tointeger(t4)  * 5 + tointeger(t5)  * 6 + tointeger(t6)  * 7;
	    tot  += tointeger(t11) * 8 + tointeger(t12) * 9 + tointeger(t13) * 2 + tointeger(t14) * 3 + tointeger(t15) * 4 + tointeger(t16) * 5 ;
		
	var result = tointeger(tot) % 11;
	result = ( 11 - tointeger(result) ) % 10;
	
	if (result == t17) {
		return true;
	} else {
		return false;
	}
}


/*------------------------------------------------------------------
/기능 : 외국인등록번호 형식 check
/인수 : 외국인등록번호 
/리턴 : boolean
------------------------------------------------------------------*/
function gfn_adv_chkForeignerJuminNo(strRegNo) {
	strRegNo = replace(strRegNo, "-", "");
    
    
	//trace("strRegNo="+strRegNo);
	// trace("strRegNo.charAt(0)="+strRegNo.charAt(0));
	// trace("strRegNo.charAt(1)="+strRegNo.charAt(1));
	// trace("strRegNo.charAt(5)="+strRegNo.charAt(5));
	
    var birth      = "";
	var birthYear  = "";
	var birthMonth = "";
	var birthDate  = "";
	
	if (strRegNo == ""){ 
	        alert('외국인등록번호를 입력하십시오.'); 
	        return false; 
	} 
	
	if (strRegNo.length != 13) { 
	        alert('외국인등록번호 자리수가 맞지 않습니다.\n\n확인하시기 바랍니다.'); 
	        return false; 
	} 
	
	if ((strRegNo.charAt(6) == "5") || (strRegNo.charAt(6) == "6")) {
	   birthYear = "19"; 
	
	} else if ((strRegNo.charAt(6) == "7") || (strRegNo.charAt(6) == "8")) {
	   birthYear = "20"; 
	   
	} else if ((strRegNo.charAt(6) == "9") || (strRegNo.charAt(6) == "0")) { 
	   birthYear = "18"; 
	   
	} else	{ 
	  alert("등록번호에 오류가 있습니다.\n\n확인하시기 바랍니다."); 
	  return false; 
	  
	}         
	
	birthYear += strRegNo.substr(0, 2); 
	//birthMonth = toNumber(strRegNo.substr(2, 2)) - 1; //630116-*******에서 오류 정정
	birthMonth = toNumber(strRegNo.substr(2, 2));    
	birthDate  = strRegNo.substr(4, 2); 
	

	
	// trace("birthYear="+birthYear);
	// trace("birthMonth="+birthMonth);
	// trace("birthDate="+birthDate);

	birth = DateTime(birthYear, birthMonth, birthDate); 
	 

	// trace("birth="+birth); 
	// trace("Year="+ toString( toNumber( left(birth,4) )%100 ) ); 
	// trace("Month="+substr(birth,4,2)); 
	// trace("Day="+right(birth,2));
	  
	if ( toNumber( left(birth,4) )%100  != toNumber(strRegNo.substr(0, 2)) || 
	     toNumber(substr(birth,4,2)) != toNumber(birthMonth) || 
	     toNumber(right(birth,2)) != toNumber(birthDate)) { 
	  alert('외국인등록번호 생년월일에 오류가 있습니다.\n\n확인하시기 바랍니다.'); 
	  return false; 
	} 
	
	
	return true;
}

/*------------------------------------------------------------------------------
* 기   능: 그리드 저장시 필수항목 Null 체크
* 인   수: objGrid      : Grid object
*		   arrColumnID  : 필수입력에 해당하는 컬럼ID array  
*		   arrColumnNM  : 필수입력에 해당하는 컬럼명 array
* Return : 적합여부 ( true/ false )
------------------------------------------------------------------------------*/
function gfn_adv_chkGridNull_Full(objGrid, arrColumnID, arrColumnNM)
{
	var objBindDS  = object( objGrid.BindDataset );
	var sData;
	
	for (i=0;  i< objBindDS.RowCount();  i++) {
		if(objBindDS.GetRowType(i) == "normal") continue;
		 
		for(j=0;  j<length(arrColumnID);  j++) {
			sData = objBindDS.GetColumn(i, arrColumnID[j]);

			if (( length(trim(sData + "")) == 0 )) {
				
				alert( arrColumnNM[j] + "을(를) 입력해 주시기 바랍니다.");
				
				object( objGrid.BindDataset ).RowPosition = i;
				return false;
			}
		} 
	}
	
	return  true;	
}


/*------------------------------------------------------------------------------
* 기   능:	Grid Sort Mark 제거
* 인   수:  vaInput : objGrid 또는 Array
				사용자의 편의에 따라 단일 Object을 보낼 수 도 있고
				Array를 만들어 Object를 담아서 보낼 수 도 있다.
* Return : 	N/A
------------------------------------------------------------------------------*/
function gfn_adv_removeSortMark(vaInput)
{	
	var sType = type(vaInput);
	var iColCnt;
	var sRepText;	
	var sDatasetID;
	
	if(sType == "object"){
		iColCnt = vaInput.GetCellCount("head");
		
		for(i=0;  i < iColCnt; i++){		
			sRepText = replace(vaInput.GetCellProp("head",i,"text"), jv_sASC_MARK,"");
			vaInput.SetCellProp("head",i,"text", sRepText);
			
			sRepText = replace(vaInput.GetCellProp("head",i,"text"), jv_sDESC_MARK,"");
			vaInput.SetCellProp("head",i,"text", sRepText);
					
		}
	
	} else if(sType == "ARRAY"){
		for(var i=0;  i<vaInput.length;  i++) {
			iColCnt = vaInput[i].GetCellCount("head");

			for(j=0;  j < iColCnt; j++){		
				sRepText = replace(vaInput[i].GetCellProp("head",j,"text"), jv_sASC_MARK,"");
				vaInput[i].SetCellProp("head", j, "text", sRepText);
				
				sRepText = replace(vaInput[i].GetCellProp("head",j,"text"), jv_sDESC_MARK,"");
				vaInput[i].SetCellProp("head", j, "text", sRepText);				
			}
		}
	
	}
	
}


/*************************************************************************************************
>>> Etc.
*************************************************************************************************/
/************************************************************
* 기   능: 해당 데이터셑의 내용을 상세히 보여준다. 
* 인   수: objDS      ( Dataset )
*          bOpenstyle ( OPEN유무 true, false)
* Return : N/A
*************************************************************/
function gfn_adv_debug(objDS, bOpenstyle) {
	var sDS_NAME = objDS.id;

	if(bOpenstyle) {
		Open("zsample::Debug.xml", "p_dataset_id="+quote(sDS_NAME) , 800, 600, "Resize=true");
		
	} else {
		Dialog("zsample::Debug.xml", "p_dataset_id="+quote(sDS_NAME) ,800, 600, "Resize=true");
	}
}




﻿﻿﻿/*********************************************************************
 * 기능 : 그리드의 선택영역을 Clipboard로 Copy 한다.
 * 인수 : objGrid       : Area Select 된 Grid
         strSeparator  : Colunm 구분자.
 * 예제 : grd_fn_ClipboardCopy(objGrid, ",");
 * 2011.04.05 현명환
 *********************************************************************/
function grd_fn_CellCopy(objGrid) {
	grd_fn_ClipboardCopy(objGrid, "	");
}

function grd_fn_ClipboardCopy(objGrid, strSeparator) {

	var orgDataset = eval(objGrid.BindDataset);

	var strColID;
	var strValue;

	var strClipboard = "";

	var nAreaStartRow;
	var nAreaEndRow;
	var nAreaStartCol;
	var nAreaEndCol;

	if(objGrid.AreaSelect == true) {

		nAreaStartRow = objGrid.GetAreaStartRow();
		nAreaEndRow   = objGrid.GetAreaEndRow();
		nAreaStartCol = objGrid.GetAreaStartCol();
		nAreaEndCol   = objGrid.GetAreaEndCol();

	} else {

		nAreaStartRow = objGrid.CurrentRow;
		nAreaEndRow   = objGrid.CurrentRow;
		nAreaStartCol = objGrid.CurrentCell;
		nAreaEndCol   = objGrid.CurrentCell+1;
	}

	for(var nRow = nAreaStartRow; nRow <= nAreaEndRow; nRow++) {

		for(var nCell = nAreaStartCol; nCell <= nAreaEndCol; nCell++) {

			if(objGrid.GetColProp(nCell,"Width") > 0) {

				strColID = objGrid.GetCellProp("body",nCell,"colid");
				//strValue = orgDataset.GetColumn(nRow,strColID);
				
				strValue = grdList.GetCellText("body",nRow,nCell);
				
				strClipboard = strClipboard + strValue + strSeparator;

			}
		}

		strClipboard = substr(strClipboard,0,length(strClipboard)-1);
		strClipboard = strClipboard + "\n";
	}

	strClipboard = substr(strClipboard,0,length(strClipboard)-1);

	ClearClipboard();
	SetClipBoard("CF_UNICODETEXT",strClipboard);

	return;
}

/*********************************************************************
 * 기능 : Clipboard에 Copy된 내용을 그리드의 선택된 영역에 Paste 한다.
 * 인수 : objGrid       : Area Select 된 Grid
         strSeparator  : Colunm 구분자.
 * 예제 : grd_fn_ClipboardPaste(objGrid, ",");
 * 2011.04.05 현명환
 *********************************************************************/
function grd_fn_CellPaste(objGrid) {
	grd_fn_ClipboardPaste(objGrid, "	");
}

function grd_fn_ClipboardPaste(objGrid, strSeparator) {

	var orgDataset = eval(objGrid.BindDataset);

	var nSearchRow = 0;
	var nSearchCol = 0;
	var strColID;
	var strValue;
	var strBgColor;

	// 숫자 자릿수 구분은 comma 를 사용하기 때문에 호환을 위해서 comma 를 제거한다.
	var strClipboardData = replace(GetClipBoard("CF_UNICODETEXT"),",","");

	if(strSeparator != " ") {
		// 유럽의 숫자 자릿수 구분은 space 를 사용하기 때문에 호환을 위해서 space 를 제거한다.
		strClipboardData = replace(strClipboardData," ","");
	}

	//var strClipboardRecord = split(strClipboardData,"\n","webstyle"); 
	var strClipboardRecord = split(strClipboardData,"\n"); //수정 
	
	trace(strClipboardRecord);
	
	var strClipboardColunm;

	var nAreaStartRow;
	var nAreaEndRow;
	var nAreaStartCol;
	var nAreaEndCol;

	if(objGrid.AreaSelect == true) {

		nAreaStartRow = objGrid.GetAreaStartRow();
		nAreaEndRow   = objGrid.GetAreaEndRow();
		nAreaStartCol = objGrid.GetAreaStartCol();
		nAreaEndCol   = objGrid.GetAreaEndCol();

	} else {

		nAreaStartRow = objGrid.CurrentRow;
		nAreaEndRow   = objGrid.CurrentRow;
		nAreaStartCol = objGrid.CurrentCell;
		nAreaEndCol   = objGrid.CurrentCell+1;
	}

	for(var nRow = nAreaStartRow; nRow < (nAreaStartRow + length(strClipboardRecord)); nRow++) {

		strClipboardColunm = split(strClipboardRecord[nSearchRow],strSeparator,"webstyle");

		nSearchCol = 0;
		var nAreaCell = nAreaStartCol + length(strClipboardColunm);
		for(var nCell = nAreaStartCol; nCell < nAreaCell && nCell < objGrid.GetColCount(); nCell++) {

			if(objGrid.GetColProp(nCell,"Width") > 0) {

				strColID = objGrid.GetCellProp("body",nCell,"colid");
				strBgColor = orgDataset.GetColumn(nRow,"BGCOLOR"+strColID);

				strValue = trim(strClipboardColunm[nSearchCol]);
				orgDataset.SetColumn(nRow,strColID,strValue);

				nSearchCol++;

			} else {
				nAreaCell++;
			}
		}

		nSearchRow++;
	}

	return;
}

/*********************************************************************
 * 기능 : 그리드의 선택된 영역을 Reset 한다.
 * 인수 : objGrid     : Area Select 된 Grid
 * 예제 : grd_fn_CellReset(objGrid);
 * 2011.04.05 현명환
 *********************************************************************/
function grd_fn_CellReset(objGrid) {

	var objDataset = eval(objGrid.BindDataset);

	var strColID;

	var nAreaStartRow = objGrid.GetAreaStartRow();
	var nAreaEndRow   = objGrid.GetAreaEndRow();
	var nAreaStartCol = objGrid.GetAreaStartCol();
	var nAreaEndCol   = objGrid.GetAreaEndCol();

	var strRowTitle;

	for(var nRow = nAreaStartRow; nRow <= nAreaEndRow; nRow++) {

		for(var nCell = nAreaStartCol; nCell < nAreaEndCol; nCell++) {

			strColID = objGrid.GetCellProp("body",nCell,"colid");
			objDataset.SetColumn(nRow, strColID, objDataset.GetOrgColumn(nRow, strColID));
		}
	}
}