﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿/*
 *===================================File description=============================================
 * File Name    : common_fd_adv.js
 * Comment      : FirstData 장비관련 Function
 * Create Date  : 2010/03/18
 * Author       : PBH
 *================================================================================================




>>> Function List
-------------------------------------------------------------------------------------------------
 - gfn_adv_ReadTerminalNumber       : 단말기번호 조회(수기입력시 사용)
 - gfn_adv_getMemberNumber          : 가맹점번호 조회(수기입력시 사용)
 - gfn_adv_searchFDIKPOS4_msg       : FDIKPOS4 Error Msg 조회
 - gfn_adv_searchInstallmentCD      : 신용카드 할부개월 공통코드 조회
 - gfn_adv_searchCardCompCD         : 신용카드 회계계정 공통코드 조회
 - gfn_adv_getCardAccount           : 신용카드(매입사+발급사 기준) 회계계정 반환
 - gfn_adv_CallBack                 : common_fd_adv.js callback 함수
 - gfn_adv_FDIKPOS4_error           : FDIKPOS4 Error Msg 표시
 - gfn_adv_errorCommProcess         : Error발생시 공통처리 함수
 - gfn_adv_setPOS4CAT               : POS4CAT component 설정
 - gfn_adv_setFDIKPOS4              : FDIKPOS component 설정
 - gfn_adv_UnInitialize             : 인터넷 승인모듈 해제
 - gfn_adv_init_FDIK_var            : 결제 관련 변수 초기화
 - gfn_adv_Track2AndSignReadWithValue : 결제요청
 - gfn_adv_CreditAuthPrint          : 신용승인 전표인쇄
 - gfn_adv_CreditAuthFail           : 망취소 처리
 - gfn_adv_posDownload              : POS용 CAT ID 등록을 위한 POS 다운로드 서비스
*/

//카드장비관련 변수
var jv_srvExecType              = "";  //서비스실행유형(D1:신용승인, D2:신용취소)
var jv_termid                   = "";  //단말기 번호
var jv_SeqNum                   = "";  //거래 일련번호
var jv_responseCode             = "";  //서비스 결과 응답코드
var jv_responseMsg				= "";  //서비스 결과 응답메시지
var jv_track2Data               = "";  //Track2 Data
var jv_cardNumber               = "";  //카드번호
var jv_cardName                 = "";  //카드명
var jv_InstallmentPeriod        = "";  //할부개월

var jv_cashReceiptTranType      = "";  //현금영수증 거래유형
var jv_authTime                 = "";  //승인일시(YYMMDD)
var jv_transactionDate			= "";  //거래일시(YYMMDDhhmmss)
var jv_authAmount               = "";  //승인금액
var jv_authNumber               = "";  //승인번호
var jv_issuerCode               = "";  //발급사 코드
var jv_issuerName               = "";  //발급사 명

var jv_acquirerCode             = "";  //매입사 코드
var jv_acquirerName             = "";  //매입사 명
var jv_cardResCode              = "";  //카드사 응답코드

var jv_MemberNumber             = "";  //가맹점번호
var jv_ddcFlag                  = "";  //DDC flag ('D' : 수기서명 'S' 전자서명 )
var jv_ddcNumber                = "";  //DDC 전표번호 추출(최대 10자)
var jv_chkCardFlag              = "";  // 체크 카드 플래그 'Y' : 체크카드 'N': 기타 카드
var jv_VAT                      = "";  //부가세


var jv_notice                   = "";  //notice
var jv_displayData              = "";  //화면표시 Data
var jv_announceData             = "";  //알림메시지 
//var jv_cashReceiptAuthNumber  = "";  //현금영수증 승인/취소 결과는 승인번호를 참조.
var jv_cashReceiptAnnounceData  = "";  //현금영수증 알림 메시지
var jv_wcc                      = "";  //WCC ('S' : Swipe 'K':KeyIn)
var jv_trackData                = "";  //Track Data(Track2Read로 가져오는 Track2 Data와의 차이는)
var jv_cardYYYYMM               = "";  //유효년월


   //--현금영수증 관련
var jv_tran_type                = "";  //현금영수증 거래유형 (00 : 소비자소득공제, 01 : 사업자지출증빙)

var jv_objPOS4CAT  = ""; //POS4CAT object
var jv_objFDIKPOS4 = ""; //FDIKPOS object

//기타
var jv_sPrintErrMSG = ""; //인쇄 에러메시지
var jv_pos_Initial  = "NSDMS"; //업체 POS 업체 Initial


/*------------------------------------------------------------------------------
* 기   능:	단말기번호 조회(수기입력시 사용)
* 인   수:  N/A
* Return :  단말기번호
------------------------------------------------------------------------------*/
function gfn_adv_ReadTerminalNumber()
{
	var strTermNum = jv_objFDIKPOS4.ReadTerminalNumber();
	
	return strTermNum;
}



/*------------------------------------------------------------------------------
* 기   능:	가맹점번호 조회(수기입력시 사용)
            가맹점에 단말기가 2대이상이어도 가맹점번호는 1개다.

* 인   수:  strShop_cd (정비점코드)
* Return :  가맹점번호
------------------------------------------------------------------------------*/
function gfn_adv_getMemberNumber(strShop_cd)
{
	var strMemberNumber = "";
    var iFindRow = -1; 
    
    iFindRow = gdsPOS_info.FindRow("shop_cd", strShop_cd);

    if(iFindRow > -1) {
		strMemberNumber = gdsPOS_info.GetColumn(iFindRow, "member_no");
    }
	
	//trace("strMemberNumber="+strMemberNumber);
	return strMemberNumber;
}
 
/*------------------------------------------------------------------------------
* 기   능:	FDIKPOS4 Error Msg 조회
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_searchFDIKPOS4_msg()
{
  
	if(gdsFDIKPOS4msg.RowCount() == 0) {
		gfn_SyncTransaction(this, "FDIKPOS4msg",
		"Svr_JSP::cc-codeList-listOnlyCode?inParams=1085",
		"",
		"gdsFDIKPOS4msg=outDs1",
		"",
		"gfn_adv_CallBack");	
	}
}


/*------------------------------------------------------------------------------
* 기   능:	신용카드 할부개월 공통코드 조회
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_searchInstallmentCD()
{ 
	if(gdsInstMtCD.RowCount() == 0) {
		gfn_SyncTransaction(this, "Installment",
		"Svr_JSP::cc-codeList-listOnlyCode?inParams=4036",
		"",
		"gdsInstMtCD=outDs1",
		"",
		"gfn_adv_CallBack");	
	}
}


/*------------------------------------------------------------------------------
* 기   능:	결제시스템 Test정비점 공통코드 조회
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_searchCardRepairShop()
{ 
	if(gdsCardRepairShop.RowCount() == 0) {
		gfn_SyncTransaction(this, "searchCardRepairShop",
		"Svr_JSP::cc-codeList-listOnlyCode?inParams=1087",
		"",
		"gdsCardRepairShop=outDs1",
		"",
		"gfn_adv_CallBack");	
	}
	
}



/*------------------------------------------------------------------------------
* 기   능:	결제시스템 Test정비점 여부 반환
* 인   수:  N/A
* Return :  boolean
------------------------------------------------------------------------------*/
/*
function gfn_adv_isTestRepairShop()
{ 
	alert("common_lib.js로 이동");
	trace("gfn_adv_isTestRepairShop global.SHOP_CD="+global.SHOP_CD);
	var bRtn = false;
	if(gdsCardRepairShop.FindRow("code", global.SHOP_CD) > (-1)) {
		bRtn = true;
	}
	
	return bRtn;
}
*/


/*------------------------------------------------------------------------------
* 기   능:	신용카드 회계계정 공통코드 조회
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_searchCardCompCD()
{ 
	if(gdsCardComp.RowCount() == 0) {
		gfn_SyncTransaction(this, "SearchCardComp",
		"Svr_JSP::cc-codeList-listOnlyCode?inParams=1086",
		"",
		"gdsCardComp=outDs1",
		"",
		"gfn_adv_CallBack");	
	}
}


/*------------------------------------------------------------------------------
* 기   능:	신용카드(매입사+발급사 기준) 회계계정 반환
* 인   수:  N/A
* Return :  회계계정
------------------------------------------------------------------------------*/
function gfn_adv_getCardAccount(acquirerIssueCD)
{ 
	var iRow = gdsCardComp.FindRow("code", acquirerIssueCD);
	var strAccount = "";
	if(iRow < 0) {
		alert("해당 신용카드의 회계계정(공통1086 acquirerIssueCD="+ acquirerIssueCD +")을 찾을 수 없습니다.\n\nNSDMS 시스템담당자에게 문의 바랍니다.");
	} else {
		strAccount = gdsCardComp.GetColumn(iRow, "etc1");
	}
	
	trace("acquirerIssueCD="+acquirerIssueCD);
	trace("gfn_adv_getCardAccount="+strAccount);
	return strAccount;
}

//common_fd_adv.js callback 함수
function gfn_adv_CallBack(svrId, errCd, errMsg) 
{
	if(errCd < 0) {
		alert(svrId + "  " + errMsg);
	}
}


/*------------------------------------------------------------------------------
* 기   능:	FDIKPOS4 Error Msg 표시
* 인   수:  Error code
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_FDIKPOS4_error(ErrCD)
{
	//인터넷 승인모듈 해제
	gfn_adv_UnInitialize();

	var iRow = gdsFDIKPOS4msg.FindRow("code", ErrCD);
  
	if(iRow < 0) {
		if(ErrCD == 1) {
			alert("FDIKPOS4 에러코드 " + ErrCD + " - 처리중 자동망취소 되었습니다.\n다시 시도하시기 바랍니다.");
			return;
		}
	
		alert("FDIKPOS4 에러코드 " + ErrCD + "을 찾을 수 없습니다.");
	} else {
		var strMsg1 = gdsFDIKPOS4msg.GetColumn(iRow, "code_nm");
		var strMsg2 = trim(gdsFDIKPOS4msg.GetColumn(iRow, "etc1"));
		// var strMsg3 = trim(gdsFDIKPOS4msg.GetColumn(iRow, "etc2"));
		// var strMsg4 = trim(gdsFDIKPOS4msg.GetColumn(iRow, "etc3"));
		
		if(length(strMsg2) > 0) {
			alert("오류메시지 1번="+strMsg1 + "\n오류메시지 2번="+strMsg2);
		} else {
			alert("오류메시지 : "+strMsg1);
		}
	}
	
	//Error발생시 공통처리 함수
	gfn_adv_errorCommProcess();
}


/*------------------------------------------------------------------------------
* 기   능:  Error발생시 공통처리 함수
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_errorCommProcess()
{
	//amss0107.xml 함수 호출
	fn_stepErrorCommProcess();
}

/*------------------------------------------------------------------------------
* 기   능:	POS4CAT component 설정
* 인   수:  POS4CAT object
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_setPOS4CAT(objPOS4CAT)
{
	jv_objPOS4CAT = objPOS4CAT;
}


/*------------------------------------------------------------------------------
* 기   능:	FDIKPOS component 설정
* 인   수:  FDIKPOS object
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_setFDIKPOS4(objFDIKPOS4)
{
	jv_objFDIKPOS4 = objFDIKPOS4;
}



/*------------------------------------------------------------------------------
* 기   능:	인터넷 승인모듈 해제
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_UnInitialize()
{
	//gfn_adv_init_FDIK_var();
	jv_objPOS4CAT.ServiceExit();
	jv_objFDIKPOS4.UnInitialize();
}


/*------------------------------------------------------------------------------
* 기   능:	결제 관련 변수 초기화
* 인   수:  N/A
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_init_FDIK_var()
{
	jv_srvExecType              = "";  //서비스실행유형(D1:신용승인, D2:신용취소)
	jv_termid                   = "";  //단말기 번호
	jv_SeqNum                   = "";  //거래 일련번호
	jv_responseCode             = "";  //서비스 결과 응답코드
	jv_responseMsg				= "";  //서비스 결과 응답메시지
	jv_track2Data               = "";  //Track2 Data
	jv_cardNumber               = "";  //카드번호
	jv_cardName                 = "";  //카드명
	jv_InstallmentPeriod        = "";  //할부개월
	jv_cashReceiptTranType      = "";  //현금영수증 거래유형
	jv_authTime                 = "";  //승인일시(YYMMDD)
	jv_transactionDate			= "";  //거래일시(YYMMDDhhmmss)
	jv_authAmount               = "";  //승인금액
	jv_authNumber               = "";  //승인번호
	jv_issuerCode               = "";  //발급사 코드
	jv_issuerName               = "";  //발급사 명
	
	jv_acquirerCode             = "";  //매입사 코드
	jv_acquirerName             = "";  //매입사 명
	jv_cardResCode              = "";  //카드사 응답코드
	
	jv_MemberNumber             = "";  //가맹점번호
	jv_ddcFlag                  = "";  //DDC flag ('D' : 수기서명 'S' 전자서명 )
	jv_ddcNumber                = "";  //DDC 전표번호 추출(최대 10자)	
	jv_chkCardFlag              = "";  // 체크 카드 플래그 'Y' : 체크카드 'N': 기타 카드
	jv_VAT                      = "";  //부가세
	
	jv_notice                   = "";  //notice
	jv_displayData              = "";  //화면표시 Data
	jv_announceData             = "";  //알림메시지 
	jv_cashReceiptAnnounceData  = "";  //현금영수증 알림 메시지
	jv_wcc                      = "";  //WCC ('S' : Swipe 'K':KeyIn)
	jv_trackData                = "";  //Track Data(Track2Read로 가져오는 Track2 Data와의 차이는)
	jv_cardYYYYMM               = "";  //유효년월
	
	jv_tran_type                = "";
}


/*------------------------------------------------------------------------------
* 기   능:	결제요청(신용승인/신용취소)
* 인   수:  
	  //1'st - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
	  //2'nd - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"   
	  //3'rd - 서비스실행유형(D1:신용승인, D2:신용취소)
	  //4'th - 신용취소시 (승인번호)
	  //5'th - 신용취소시 (승인일자)
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_Track2AndSignReadWithValue(Amount, installmentData, srvID, cancelAuthNumber, cancelAuthTime)
{
	jv_srvExecType = srvID;
	
	jv_authAmount = toNumber(Amount); //실수형으로 변환
	jv_InstallmentPeriod = installmentData;
	var nRet = 0;
	
	//iPos(인터넷 승인모듈)초기화
	nRet = jv_objFDIKPOS4.Initialize();
	
	if(nRet == 0) {
		//iPos(인터넷 승인모듈)공통 부분 데이터 설정
		//1'st - 단말기 번호 , 미입력시 ""(INI 파일을 이용한 설정)
		//2'nd - 거래 일련번호, 미 입력시 ""(INI 파일을 이용한 설정)
		//3'th - POS 업체 Initial, 미 입력시 ""
		//4'th - 가맹점 임의 정보, 미 입력시 ""
		//5'th - 취소 유형, 미 입력시 "", 망취소 "7", 일반취소 "0"
		
		jv_termid = jv_objFDIKPOS4.ReadTerminalNumber();	  //단말기 번호
		jv_SeqNum = jv_objFDIKPOS4.ReadTranSequenceNumber(); //거래 일련번호
	
		//승인취소시
	    if(srvID == "D2") {
			nRet = jv_objFDIKPOS4.SetCommonData(jv_termid, jv_SeqNum, jv_pos_Initial, "", "0");
		
		} else {
			nRet = jv_objFDIKPOS4.SetCommonData(jv_termid, jv_SeqNum, jv_pos_Initial, "", "");
		
		}
		
		//trace("jv_termid="+ jv_termid + "  jv_SeqNum="+ jv_SeqNum + "  nRet="+ nRet);
		
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			gfn_adv_UnInitialize();
			return;
	    }
	    
		//1'st - 단말기 번호 , 미입력시 ""(INI 파일을 이용한 설정)
		//2'nd - 거래 일련번호, 미 입력시 ""(INI 파일을 이용한 설정)
		//3'th - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
		//4'th - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"   
        nRet = jv_objPOS4CAT.Track2AndSignReadWithValue(jv_termid, jv_SeqNum, jv_authAmount, jv_InstallmentPeriod);
		
		
		//부가세
		jv_VAT = truncate(jv_authAmount/11); 

		if(nRet <> 0) {
			alert("카드읽기 및 사인요청에 실패했습니다. 에러코드=" + nRet);
			gfn_adv_UnInitialize();
			
			//amss0107.xml 함수 호출
			fn_stepCardReadingFail(); //카드읽기 button 활성화
			//Error발생시 공통처리 함수
			gfn_adv_errorCommProcess();			
			return;
		}
		
		jv_track2Data = jv_objPOS4CAT.GetTrackData();
		jv_wcc        = jv_objPOS4CAT.GetWCC();

		
		var arrTrackData = split(jv_track2Data, "=");
		jv_cardNumber    = arrTrackData[0];
		jv_cardYYYYMM    = left(arrTrackData[1], 4);		
		

		//amss0107.xml 함수 호출
		idle();
		fn_stepCardReadingComplete();
		idle();
		
		//trace(jv_track2Data);
		// gfn_adv_UnInitialize();	
		// return;		
		
		
		var ComMethod = jv_objPOS4CAT.GetSignPADComMethod();
		var HashValue = jv_objPOS4CAT.GetSignPADHashValue();
		var SignData  = jv_objPOS4CAT.GetSignPADSignDataASCII();
		
		// alert("ComMethod="+ComMethod);
		// alert("HashValue="+HashValue);
		 // alert("SignData="+SignData);
		
		nRet = jv_objFDIKPOS4.SetSignInfo(ComMethod, "S1", HashValue, SignData);
	
		//iPos(인터넷 승인모듈)신용카드 정보 설정
		//1'st - 신용카드 정보(TrackData) , 반드시 입력(최대 37자)
		//2'nd - 신용카드 정보 입력 유형, ("S"-Swipe, "K"-Keyin, "O"-통합동글, "R"-일반 동글), 신용카드 정보 입력시 반드시 입력
		//3'th - 암호화 키 Index, 2자리, 비밀번호 데이터 입력시 반드시 입력
		//4'th - 비밀번호 데이터 , 16자리, 암호화 키 데이터 입력시 반드시 입력      
		
		//trace("jv_track2Data="+ jv_track2Data + "  jv_wcc="+ jv_wcc );
		nRet = jv_objFDIKPOS4.SetCreditInfo(jv_track2Data, jv_wcc, "", "");		
	
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		
		//금액 정보 설정
		//1'st - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
		//2'nd - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"
		//3'th - 봉사료 , 미 입력시 ""
		//4'th - 세금, 미 입력시 ""
		//5'th - 통화 코드 , 원화 - "410", 달러 - "840"
		//승인취소시
		if(srvID == "D2") {
			nRet = jv_objFDIKPOS4.SetAmountInfo(jv_authAmount, jv_InstallmentPeriod, "", "", "410");
		} else {
			nRet = jv_objFDIKPOS4.SetAmountInfo(jv_authAmount, jv_InstallmentPeriod, "", jv_VAT, "410");
		}
		
					
		
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		
		//승인취소시
		if(srvID == "D2") {
			trace("승인취소 cancelAuthNumber="+cancelAuthNumber+"  cancelAuthTime="+cancelAuthTime);
			nRet = jv_objFDIKPOS4.SetCancelInfo(cancelAuthNumber, cancelAuthTime); //취소를 위한 승인번호와 승인일자
			
			if(nRet <> 0) {
				gfn_adv_FDIKPOS4_error(nRet);
				return;
			}		
		}
		
		
		//amss0107.xml 함수 호출
		idle();
		fn_stepExecuteService();		
		idle();

		//서비스 실행 
		//1'st - 실행할 서비스 정보(신용승인 - "D1", 신용취소 - "D2")		
		nRet = jv_objFDIKPOS4.ExecuteService(srvID);	
			
		if(nRet <> 0) {
			if(nRet == -1) {  //망취소를 수행하여야 함.
				 //amss0107.xml 함수 호출
				 idle();
				 fn_stepCreditAuthFail();
				 idle();
				 
				 gfn_adv_CreditAuthFail(); //망취소 처리
	
			} else {
				//일반 오류가 발생함.
				//에러코드표를 참조하여야 함.
				gfn_adv_FDIKPOS4_error(nRet);
			}
				
			return;
		}         
         
		//승인서버로부터 수신된 응답전문 중 응답 코드를 추출 한다.
		jv_responseCode = jv_objFDIKPOS4.GetResponseCode();         
         
        //정상처리 
		if(jv_responseCode == "0000") {
			//응답전문 데이터를 추출.
			//승인번호 추출.(최대 12자)
			jv_authNumber = jv_objFDIKPOS4.GetAuthNumber();
			//승인일자 추출(YYMMDD Type)
			jv_authTime = jv_objFDIKPOS4.GetAuthDate();
			//trace("1 jv_authTime="+jv_authTime);
			//승인금액
			jv_authAmount = toNumber(jv_objFDIKPOS4.GetTotalAmount());  			
			//응답메시지 추출(최대 32자)
			jv_responseMsg = jv_objFDIKPOS4.GetResponseMessage();
			//카드명 추출(최대 32자)
			jv_cardName = jv_objFDIKPOS4.GetCardName();
			//발급사코드 추출(최대 2자 - 발급사,매입사코드표 참조)
			jv_issuerCode = jv_objFDIKPOS4.GetIssuerCode();
			//발급사 명 추출(최대 8자)
			jv_issuerName = jv_objFDIKPOS4.GetIssuerName();
			//매입사코드 추출(최대 2자 - 발급사,매입사코드표 참조)
			jv_acquirerCode = jv_objFDIKPOS4.GetPurchaseCode();
			//매입사명 추출(최대 8자)
			jv_acquirerName = jv_objFDIKPOS4.GetPurchaseName();
			//카드사 응답코드 추출(최대 2자)
			jv_cardResCode = jv_objFDIKPOS4.GetCardCorpResponseCode();
			//가맹점 번호 추출(최대 15자)
			jv_MemberNumber = jv_objFDIKPOS4.GetMemberStoreNumber();
			//DDC Flag 추출(1자, "D" - DDC 매입, " "(space) - 기타)
			jv_ddcFlag = jv_objFDIKPOS4.GetDDCEnable();
			//DDC 전표번호 추출(최대 10자)
			//alert("jv_ddcFlag="+jv_ddcFlag);
			jv_ddcNumber = jv_objFDIKPOS4.GetDDCSlipNumber();
			//Notice 추출(최대 20자)
			jv_notice = jv_objFDIKPOS4.GetNotice();
			 
			 
			//거래일시
			jv_transactionDate = jv_objFDIKPOS4.GetTransactionDate();
			//trace("거래일시 jv_transactionDate="+jv_transactionDate);
			
			
			//할부개월
			jv_InstallmentPeriod = jv_objFDIKPOS4.GetInstallmentPeriod();
			
			// 체크 카드 플래그 'Y' : 체크카드 'N': 기타 카드
			jv_chkCardFlag = jv_objFDIKPOS4.GetCheckCardFlag();
			

			//amss0107.xml 함수 호출
			idle();
			fn_stepBeforePrint();
			idle();
		
		} else {
			//승인서버로 부터 오류, 또는 장애등의 비정상 응답을 수신함.
			var strResponseMsg = jv_objFDIKPOS4.GetResponseMessage();
			alert("문제가 발생했습니다. \n\n[사유] : " + strResponseMsg +"\n[응답코드] : " + jv_responseCode);
			//Error발생시 공통처리 함수
			gfn_adv_errorCommProcess();				
			gfn_adv_UnInitialize();
			
			//Error Msg를 진행상태에 표시할때 사용
			fn_stepErrorMsgDisp(strResponseMsg);
			return;
		}
		
	} else {
		gfn_adv_FDIKPOS4_error(nRet);
		return;
	}
	
	//인터넷 승인모듈 해제
	//gfn_adv_UnInitialize();
}



/*------------------------------------------------------------------------------
* 기   능:	수기입력 신용승인 결제요청
* 인   수:  
      //1'st - 카드번호 + "=" + 연월
	  //2'nd - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
	  //3'rd - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"      
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_ManualCreditAuth(track2Data, Amount, installmentData)
{
	jv_srvExecType = "D1";
		
	jv_authAmount = toNumber(Amount); //실수형으로 변환
	jv_InstallmentPeriod = installmentData;
	var nRet = 0;
	
	//iPos(인터넷 승인모듈)초기화
	nRet = jv_objFDIKPOS4.Initialize();
	
	if(nRet == 0) {
		//iPos(인터넷 승인모듈)공통 부분 데이터 설정
		//1'st - 단말기 번호 , 미입력시 ""(INI 파일을 이용한 설정)
		//2'nd - 거래 일련번호, 미 입력시 ""(INI 파일을 이용한 설정)
		//3'th - POS 업체 Initial, 미 입력시 ""
		//4'th - 가맹점 임의 정보, 미 입력시 ""
		//5'th - 취소 유형, 미 입력시 "", 망취소 "7", 일반취소 "0"
		
		jv_termid = jv_objFDIKPOS4.ReadTerminalNumber();	  //단말기 번호
		jv_SeqNum = jv_objFDIKPOS4.ReadTranSequenceNumber(); //거래 일련번호
	
		nRet = jv_objFDIKPOS4.SetCommonData(jv_termid, jv_SeqNum, jv_pos_Initial, "", "");
		
		trace("jv_termid="+ jv_termid + "  jv_SeqNum="+ jv_SeqNum + "  nRet="+ nRet);
		
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			gfn_adv_UnInitialize();
			return;
	    }
	    
		//부가세
		jv_VAT = truncate(jv_authAmount/11);
			    
		
		jv_track2Data = track2Data;
		jv_wcc        = "K";  //Keyin > 수기서명

		
		var arrTrackData = split(jv_track2Data, "=");
		jv_cardNumber    = arrTrackData[0];
		jv_cardYYYYMM    = left(arrTrackData[1], 4);		
		

		//amss0107.xml 함수 호출
		idle();
		fn_stepCardReadingComplete();
		idle();
		
	
		//iPos(인터넷 승인모듈)신용카드 정보 설정
		//1'st - 신용카드 정보(TrackData) , 반드시 입력(최대 37자)
		//2'nd - 신용카드 정보 입력 유형, ("S"-Swipe, "K"-Keyin, "O"-통합동글, "R"-일반 동글), 신용카드 정보 입력시 반드시 입력
		//3'th - 암호화 키 Index, 2자리, 비밀번호 데이터 입력시 반드시 입력
		//4'th - 비밀번호 데이터 , 16자리, 암호화 키 데이터 입력시 반드시 입력    
		nRet = jv_objFDIKPOS4.SetCreditInfo(jv_track2Data, jv_wcc, "", "");		
	
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		
		//금액 정보 설정
		//1'st - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
		//2'nd - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"
		//3'th - 봉사료 , 미 입력시 ""
		//4'th - 세금, 미 입력시 ""
		//5'th - 통화 코드 , 원화 - "410", 달러 - "840"
		nRet = jv_objFDIKPOS4.SetAmountInfo(jv_authAmount, jv_InstallmentPeriod, "", jv_VAT, "410");			
		
		if(nRet <> 0) {
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		

		
		//amss0107.xml 함수 호출
		idle();
		fn_stepExecuteService();		
		idle();

		//서비스 실행 
		//1'st - 실행할 서비스 정보(신용 승인- D1,   신용취소- D2, 현금승인- K1, 현금취소- K2)		
		nRet = jv_objFDIKPOS4.ExecuteService("D1");	
			
		if(nRet <> 0) {
			if(nRet == -1) {
				 //amss0107.xml 함수 호출
				 idle();
				 fn_stepCreditAuthFail();
				 idle();
				 
				 gfn_adv_CreditAuthFail(); //망취소 처리
	
			} else {				 			
			//일반 오류가 발생함.
			//에러코드표를 참조하여야 함.
				gfn_adv_FDIKPOS4_error(nRet);
			}
				
			return;
		}         
         
		//승인서버로부터 수신된 응답전문 중 응답 코드를 추출 한다.
		jv_responseCode = jv_objFDIKPOS4.GetResponseCode();         
         
        //정상처리 
		if(jv_responseCode == "0000") {
			//응답전문 데이터를 추출.
			//승인번호 추출.(최대 12자)
			jv_authNumber = jv_objFDIKPOS4.GetAuthNumber();
			//승인일자 추출(YYMMDD Type)
			jv_authTime = jv_objFDIKPOS4.GetAuthDate();
			//승인금액
			jv_authAmount = toNumber(jv_objFDIKPOS4.GetTotalAmount());  
			//trace("jv_authAmount="+jv_authAmount);
			
			//응답메시지 추출(최대 32자)
			jv_responseMsg = jv_objFDIKPOS4.GetResponseMessage();
			//카드명 추출(최대 32자)
			jv_cardName = jv_objFDIKPOS4.GetCardName();
			//발급사코드 추출(최대 2자 - 발급사,매입사코드표 참조)
			jv_issuerCode = jv_objFDIKPOS4.GetIssuerCode();
			//발급사 명 추출(최대 8자)
			jv_issuerName = jv_objFDIKPOS4.GetIssuerName();
			//매입사코드 추출(최대 2자 - 발급사,매입사코드표 참조)
			jv_acquirerCode = jv_objFDIKPOS4.GetPurchaseCode();
			//매입사명 추출(최대 8자)
			jv_acquirerName = jv_objFDIKPOS4.GetPurchaseName();
			//카드사 응답코드 추출(최대 2자)
			jv_cardResCode = jv_objFDIKPOS4.GetCardCorpResponseCode();
			//가맹점 번호 추출(최대 15자)
			jv_MemberNumber = jv_objFDIKPOS4.GetMemberStoreNumber();
			//DDC Flag 추출(1자, "D" - DDC 매입, " "(space) - 기타)
			jv_ddcFlag = jv_objFDIKPOS4.GetDDCEnable();
			//DDC 전표번호 추출(최대 10자)
			//alert("jv_ddcFlag="+jv_ddcFlag);
			jv_ddcNumber = jv_objFDIKPOS4.GetDDCSlipNumber();
			//Notice 추출(최대 20자)
			jv_notice = jv_objFDIKPOS4.GetNotice();
			 
			 
			//거래일시
			jv_transactionDate = jv_objFDIKPOS4.GetTransactionDate();
			
			//할부개월
			jv_InstallmentPeriod = jv_objFDIKPOS4.GetInstallmentPeriod();
			
			// 체크 카드 플래그 'Y' : 체크카드 'N': 기타 카드
			jv_chkCardFlag = jv_objFDIKPOS4.GetCheckCardFlag();
			

			//amss0107.xml 함수 호출
			idle();
			fn_stepBeforePrint();
			idle();
		
		} else {
			//승인서버로 부터 오류, 또는 장애등의 비정상 응답을 수신함.
			var strResponseMsg = jv_objFDIKPOS4.GetResponseMessage();
			alert("문제가 발생했습니다. \n[사유] : " + strResponseMsg);
			//Error발생시 공통처리 함수
			gfn_adv_errorCommProcess();				
			gfn_adv_UnInitialize();	
			
			//Error Msg를 진행상태에 표시할때 사용
			fn_stepErrorMsgDisp(strResponseMsg);			
			return;
		}
		
	} else {
		gfn_adv_FDIKPOS4_error(nRet);
		return;
	}
	
}




/*------------------------------------------------------------------------------
* 기   능:	신용승인/취소 전표인쇄
* 인   수:   
	  //1'st - 서비스실행유형(D1:신용승인, D2:신용취소)
	  //2'nd - 신용취소시 (승인일자)
	  //3'rd - 재인쇄여부(Y:재인쇄)
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_CreditAuthPrint(srvID, cancelAuthTime, strRePrint)
{
	jv_srvExecType = srvID;
	var nRet = 0;
	
	//인쇄할 전표에 사용되는 항목에 대한 초기화를 수행한다.
	jv_objPOS4CAT.PrintDataInit();
	//응답코드 데이터를 설정한다.(필수) * 프린트하기위해서는 정상 승인 코드인 "0000"을 설정하여야 한다.
	jv_objPOS4CAT.SetResCodePrintData(jv_responseCode);
	//카드 번호를 설정한다(필수) *프린트하기위해서는 신용카드 번호 16자리를 반드시 설정하여야 한다.
	// trace("jv_track2Data="+jv_track2Data);
	// trace("jv_cardNumber="+jv_cardNumber);
	jv_objPOS4CAT.SetCardNumPrintData(jv_cardNumber);  //(jv_track2Data);   //(jv_cardNumber);
	
	//승인일시를 설정한다.(필수) *프린트하기위해서는 승인일시 12자리를 반드시 설정하여야 한다.(yy/mm/dd:hh:mm:ss)
	jv_objPOS4CAT.SetAuthTimePrintData(jv_transactionDate);
	//승인금액을 설정한다. (필수) *프린트하기위해서는 승인 금액을 반드시 설정하여야 한다. 최대 8자리 ex)만원 -> "10000"
	jv_objPOS4CAT.SetAuthAmountPrintData(jv_authAmount);
	//승인번호를 설정한다. (필수) *승인번호 최대 12자리를 반드시 설정하여야 한다.
	jv_objPOS4CAT.SetAuthNumberPrintData(jv_authNumber);
	//가맹점 번호를 설정한다. (필수) *프린트하기 위해서는 가맹점 번호 최대 15자리를 반드시 설정하여야 한다.
	jv_objPOS4CAT.SetMemberNumPrintData(jv_MemberNumber);
	//할부개월을 설정한다.(선택) *설정시 2자리 ex)2개월 - >"02", 3개월->"03".
	jv_objPOS4CAT.SetInstallmentPrintData(jv_InstallmentPeriod);
	//봉사료를 설정한다. (선택) *봉사료가 존재하면 봉사료에 해당하는 금액을 설정한다. ex) 천원 -> "1000"
	jv_objPOS4CAT.SetServiceAmountPrintData("");
	//세금을 설정한다. (선택) *부가세가 존재하면 부가세에 해당하는 금액을 설정한다. ex) 천원 -> "1000"
	jv_objPOS4CAT.SetTaxAmountPrintData(jv_VAT);
	
	//카드 발급사 명을 설정한다. (선택) *발급사가 존재하면 발급사 명을 설정한다.
	jv_objPOS4CAT.SetIssuerNamePrintData(jv_issuerName);
	//Notice를 설정한다. (선택) *Notice가 존재 하면 설정한다. 최대 20Byte
	if(strRePrint == "Y") {
		jv_objPOS4CAT.SetNoticePrintData(jv_notice+"-재인쇄");
	} else {
		jv_objPOS4CAT.SetNoticePrintData(jv_notice);
	}
	
	//매입사 명을 설정한다. (선택) *매입사가 존재하면 매입사 명을 설정한다. 최대 16Byte
	jv_objPOS4CAT.SetAcquirNamePrintData(jv_acquirerName);
	
	//(생략)알림 메시지를 설정한다. (선택) *알림메시지가 존재하면 알림메시지를 설정한다. 최대 112Byte
	
				
	//체크 카드일 경우
	if(jv_chkCardFlag == "Y") jv_objPOS4CAT.SetAnnouncePrintData("체크 카드 결제");
	
	
	//신용취소의 경우
	if(srvID == "D2") {
		//설정이 완료 되었으므로 단말기로 신용승인 전표 인쇄를 요청한다.
		//원거래일자를 설정한다. (YYYYMMDD)
		jv_objPOS4CAT.SetBeforeTranDatePrintData( cancelAuthTime );

		//ddc flag를 체크해서 S일 경우(DSC 거래) 만 이 함수 호출 
		if (jv_ddcFlag == "S"){
			nRet = jv_objPOS4CAT.CreditCancelAndSignPrint(jv_termid, jv_SeqNum);

		} else {
			nRet = jv_objPOS4CAT.CreditCancelResultPrint();
		}
		
	} else { //신용승인의 경우
		//ddc flag를 체크해서 S일 경우(DSC 거래) 만 이 함수 호출 
		if (jv_ddcFlag == "S"){
			nRet = jv_objPOS4CAT.CreditAuthAndSignPrint(jv_termid, jv_SeqNum);

		} else {
			nRet = jv_objPOS4CAT.CreditAuthResultPrint();
			
		}	
	}
			
	
	if(nRet != 0) {
	//단말기가 프린트가 완료 되면 0을 리턴한다.
	//0이 아닌경우는 전표 인쇄시 에러가 발생한 것이며 상세 내용은 자체 Message Box로 표시된다.
	
		//서비스를 종료 시킴, 한개의 요청이 종료되면 호출해주는 것이 바람직함	
		jv_objPOS4CAT.ServiceExit(); 	
				
		//Error발생시 공통처리 함수
		gfn_adv_errorCommProcess();		
	}else {
		//서비스를 종료 시킴, 한개의 요청이 종료되면 호출해주는 것이 바람직함	
		jv_objPOS4CAT.ServiceExit(); 	
		
		//amss0107.xml 함수 호출
		fn_stepServiceExit();
	}	
}

//망취소 처리
//strReciveMsg : Transaction Error Msg
function gfn_adv_CreditAuthFail(strReciveMsg)
{
	var nRet = 0;
	var strMsg  = "퍼스트데이타(고객센터: 1544-3850)에 연락하시기 바랍니다.\n망취소에 실패했습니다.";
		strMsg += "\n현재화면을 닫지 마시고 카드번호,승인번호,단말기번호(CATID)를 알려주시기 바랍니다.";
		strMsg += "\n\n망취소 후 결제를 다시 시도하시기 바랍니다.!";
	
	
	//iPos(인터넷 승인모듈)초기화
	nRet = jv_objFDIKPOS4.Initialize();
	
	if(nRet == 0) {
		//iPos(인터넷 승인모듈)공통 부분 데이터 설정
		//1'st - 단말기 번호 , 미입력시 ""(INI 파일을 이용한 설정)
		//2'nd - 거래 일련번호, 미 입력시 ""(INI 파일을 이용한 설정)
		//3'th - POS 업체 Initial, 미 입력시 ""
		//4'th - 가맹점 임의 정보, 미 입력시 ""
		//5'th - 취소 유형, 미 입력시 "", 망취소 "7", 일반취소 "0"
		nRet = jv_objFDIKPOS4.SetCommonData(jv_termid, jv_SeqNum, jv_pos_Initial, "", "7");
				
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			gfn_adv_UnInitialize();
			
			return;
	    }
	    	    
	
		//iPos(인터넷 승인모듈)신용카드 정보 설정
		//1'st - 신용카드 정보(TrackData) , 반드시 입력(최대 37자)
		//2'nd - 신용카드 정보 입력 유형, ("S"-Swipe, "K"-Keyin, "O"-통합동글, "R"-일반 동글), 신용카드 정보 입력시 반드시 입력
		//3'th - 암호화 키 Index, 2자리, 비밀번호 데이터 입력시 반드시 입력
		//4'th - 비밀번호 데이터 , 16자리, 암호화 키 데이터 입력시 반드시 입력      
		
		nRet = jv_objFDIKPOS4.SetCreditInfo(jv_track2Data, jv_wcc, "", "");		
	
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		
		//금액 정보 설정
		//1'st - 거래금액, (최대 10자)(ex)10000원 입력시 - 10000)
		//2'nd - 할부개월, 2자리ㅣ, 일시불 - "", 2개월 - "02"
		//3'th - 봉사료 , 미 입력시 ""
		//4'th - 세금, 미 입력시 ""
		//5'th - 통화 코드 , 원화 - "410", 달러 - "840"
		nRet = jv_objFDIKPOS4.SetAmountInfo(jv_authAmount, jv_InstallmentPeriod, "", jv_VAT, "410");			
		
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}


	    //망취소용 승인일자 설정(YYMMDD Type)
	    //trace("망취소용 승인일자 설정(YYMMDD Type)= "+jv_authTime);
	    
	    nRet = jv_objFDIKPOS4.SetApprovalDate(jv_authTime);
	    
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			gfn_adv_UnInitialize();
			
			return;
	    }
	    
	    //망취소용 승인번호 설정
	    //(space 12자리를 입력해준다. FirstData 이진규씨 답변-2010.06.15)
	    nRet = jv_objFDIKPOS4.SetApprovalNumber("            ");
	    
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			gfn_adv_UnInitialize();
			
			return;
	    }


		//서비스 실행 
		//1'st - 실행할 서비스 정보(신용 승인 - "D1", 신용취소 - "D2")
		//망취소시 "D2"로 실행.2010.06.09 tobe 박병훈
		nRet = jv_objFDIKPOS4.ExecuteService("D2");	
			
		if(nRet <> 0) {
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}         
         
		//승인서버로부터 수신된 응답전문 중 응답 코드를 추출 한다.
		jv_responseCode = jv_objFDIKPOS4.GetResponseCode();         
         
        //정상처리 
		if(jv_responseCode == "0000") {
			//응답메시지 추출(최대 32자)
			jv_responseMsg = jv_objFDIKPOS4.GetResponseMessage();
			alert("망취소에 성공했습니다.현재 결제건은 취소되었습니다.\n다시 결제하시기 바랍니다!");
			if(length(strReciveMsg) > 0) {
				alert(strReciveMsg);
			}
			
			//단독결제화면에서는 close 제외
			if(fv_argProg_id != "amcm0060") close();
		} else {
			//승인서버로 부터 오류, 또는 장애등의 비정상 응답을 수신함.
			alert(strMsg);
			gfn_adv_FDIKPOS4_error(nRet);
			return;
		}
		
	} else {
		alert(strMsg);
		gfn_adv_FDIKPOS4_error(nRet);
		return;
	}

}

//신용승인 전표인쇄
/*------------------------------------------------------------------------------
* 기   능:	POS용 CAT ID 등록을 위한 POS 다운로드 서비스
* 인   수:   
	  //1'st - 사업자번호
	  //2'nd - 단말기번호
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_posDownload(biz_no, catID)
{
   //POS용 CAT ID 등록을 위한 POS 다운로드 서비스
   //각 POS(Client)당 최초 한번은 반드시 수행하여야 함.
   

   //iPos(인터넷 승인모듈)초기화
   var nRet = jv_objFDIKPOS4.Initialize();
   if(nRet == 0) {
      //iPos(인터넷 승인모듈)공통 부분 데이터 설정
      //1'st - 단말기 번호 , 미입력시 ""(INI 파일을 이용한 설정)
      //2'nd - 거래 일련번호, 미 입력시 ""(INI 파일을 이용한 설정)
      //3'th - POS 업체 Initial, 미 입력시 ""
      //4'th - 가맹점 임의 정보, 미 입력시 ""
      //5'th - 취소 유형, 미 입력시 "", 망취소 "7", 일반취소 "0"
      nRet = jv_objFDIKPOS4.SetCommonData(catID, "", "DMS", "", "");
      
      if(nRet == 0) {
        //POS 다운로드 데이터 설정
        //1'st Parameter - 사업자 번호(10자리, 반드시 입력)
        //2'nd Parameter - POS 프로그램 버전(최대 8자, 무 입력시 "")         
        nRet = jv_objFDIKPOS4.SetDownloadInfo(biz_no, "1.0");
        
			if(nRet == 0) {
			   //서비스 실행 
			   //1'st - 실행할 서비스 정보(POS 다운로드 - "DP")
			   nRet = jv_objFDIKPOS4.ExecuteService("DP");
				   if(nRet == 0) {
					  //승인서버로부터 수신된 응답전문 중 응답 코드를 추출 한다.
					  var strResponseCode = jv_objFDIKPOS4.GetResponseCode();
					  if(strResponseCode == "0000") {
							 //응답전문이 정상임.
							 //응답전문 데이터를 추출.
							 //응답메시지 추출(최대 32자)
							 var strResponseMsg = jv_objFDIKPOS4.GetResponseMessage();
							 //제품일련번호 추출(10자)
							 var strProductNumber = jv_objFDIKPOS4.GetDownloadProductNumber();
							 //대표자 명 추출(최대 10자)
							 var strBossName = jv_objFDIKPOS4.GetDownloadBossName();
							 //가맹점 명 추출(최대 20자)
							 var strBizName = jv_objFDIKPOS4.GetDownloadMemberName();
							 //가맹점 주소 추출(최대 40자)
							 var strBizAddress = jv_objFDIKPOS4.GetDownloadMemberAddr();
							 //가맹점 전화번호 추출(최대 12자)
							 var strBizTel = jv_objFDIKPOS4.GetDownloadMemeberTel();
							 //대리점 전화번호(최대 12자)
							 var strAgencyTel = jv_objFDIKPOS4.GetDownloadAgencyTel();
							
							 alert("포스다운로드가 정상 수행되었습니다.");
					  } else {
							 //승인서버로 부터 오류, 또는 장애등의 비정상 응답을 수신함.
							 var strPosErr = "포스다운로드 '승인 거절'이 발생하였습니다.";
							    strPosErr += "\nNSDMS시스템 담당자에게 문의하시기 바랍니다.";
							    
							 alert(strPosErr);
					  }
				   } else if(nRet == -1) {
					  //망취소를 수행하여야 함.
					  //jv_objFDIKPOS4.SetCommonData()함수의 취소유형을 참조한 후 전문을 다시 
					  //구성하여 수행하여야 함.
					  alert("포스다운로드 중 네트웍 장애가 발생했습니다."); 	
				   } else {
					  //일반 오류가 발생함.
					  //에러코드표를 참조하여야 함.
					  alert(nRet);
					  gfn_adv_FDIKPOS4_error(nRet);
				   }
			}	
      }
   }
   
   //iPos(인터넷 승인모듈 해제
   jv_objFDIKPOS4.UnInitialize();

}