﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿﻿/*
 *===================================File description=============================================
 * File Name    : common_hw_adv.js
 * Comment      : 멤버쉽관련  Function
 * Create Date  : 2010/01/27
 * Author       : PBH
 *================================================================================================




>>> Function List
-------------------------------------------------------------------------------------------------
 - gfn_adv_chk_TP91_link     : 장치연결 유무 확인용
 - gfn_adv_ms_print          : 인쇄하기
 - gfn_adv_LCD_Display       : (참고용)LCD 설정
 - gfn_adv_Image_PrintEx     : 이미지 인쇄
 - gfn_adv_chk_ribbon        : 현재 장착된 리본종류 확인
 - gfn_adv_text_to_Bmp       : 텍스트를 비트맵으로 변환하기
 - gfn_adv_Image_SendEx      : 이미지 파일을 프린터의 이미지 버퍼로 전송
 - gfn_adv_buffer_clear      : 이미지 버퍼 초기화하기
 - gfn_adv_open_device       : 장치 열기
 - gfn_adv_close_device      : 장치 닫기
 - gfn_adv_setLogPath        : 로그경로 설정
 - gfn_adv_card_insert       : 카드 삽입
 - gfn_adv_card_eject        : 카드 배출
 - gfn_adv_chk_feeder        : 카드 위치확인(0: 카드 없음, 1: 투입구에 있음, 2: 프린터 내부에 있음)
 - gfn_adv_ms_read           : 카드 읽기
 - gfn_adv_ms_write          : 카드 쓰기(마그네틱쓰기)
 - gfn_adv_print_error       : 인쇄중 Error 처리
 - gfn_adv_TP91_init         : (참고용)장치 검색, 열기(참고용 함수:TP9100이 PC에 2대 이상 연결시 사용)
 

*/

var jv_openError_msg  = "'멥버쉽카드장치' 열기에 실패했습니다.";
var jv_closeError_msg = "'멥버쉽카드장치' 닫기에 실패했습니다.";	


//장치연결 유무 확인용
function gfn_adv_chk_TP91_link(objTP9100) {

	//장치 열기(연결상태 확인용)
	if(gfn_adv_open_device(objTP9100) != 0) {
		alert(jv_openError_msg);
		return -1;
	}
	
	
	//장치 닫기
	if(gfn_adv_close_device(objTP9100) != 0) {
		alert(jv_closeError_msg);
		return -1;
	}
	
	return 0;
}


/*------------------------------------------------------------------------------
* 기   능:	인쇄하기
* 인   수:  objTP9100    (TP9100 object)
			objDS        (멤버쉽카드 정보 Dataset)
			strPrintType (발급형태 new:신규, add:재발급)
* Return :  N/A
------------------------------------------------------------------------------*/
function gfn_adv_ms_print(objTP9100, objDS, strPrintType) {
	//log 기록시 사용
	//gfn_adv_setLogPath(objTP9100);

	var strMsg = "";
	var strErrorMsg = "\n\n발급을 중지 합니다.";
	var strCommMsg  = "\n\n카드번호 생성을 완료했으나,";
	    strCommMsg += "\n'카드 발급기' 연결 또는 '작동이상'으로 발급을 완료하지 못했습니다.";
	    strCommMsg += "\n'고객마스터 > 멤버쉽카드발급이력' 화면에서 재발급하시기 바랍니다.";


	if(objDS.RowCount() != 1) {
		alert("멤버쉽카드 정보 조회에 실패했습니다." + strErrorMsg);
		return;
	}
	
	//장치열기
	strMsg = jv_openError_msg;
	
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_open_device(objTP9100) != 0) {
		alert(strMsg); //open에 실패했으므로 장비 close처리 하지 않는다.
		return;
	}
	
	//########### 2010.04.14 박병훈 ############
    //TITENG 윤병길책임 요청으로 아래 카드존재유 체크를 주석처리함.
    //정비점에서 쓰는기종은 해당 함수를 지원하지 않음.
    //##########################################
	/*
	//카드 존재유무 파악(카드위치 확인)
	strMsg = "'카드위치 확인'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_chk_feeder(objTP9100) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
		
	} else {
		//0: 카드 없음, 1: 투입구에 있음, 2: 프린터 내부에 있음
		if(objTP9100.ReturnValue == 0) {
			strMsg = "발행할 카드가 없습니다.";
			if(strPrintType == "new") strMsg += strCommMsg;
			
			gfn_adv_print_error(objTP9100, strMsg);
			return;
			
		} else if(objTP9100.ReturnValue > 0) {
			
			//발행된 카드 여부 확인(새카드의 경우 -1이 리턴됨)
			strMsg = "[카드확인] 이미 발급된 카드입니다.";
			if(strPrintType == "new") strMsg += strCommMsg;
			
			if(gfn_adv_ms_read(objTP9100) != -1) {
				gfn_adv_print_error(objTP9100, strMsg);
				return;
			}
		}
	}
	*/


	//현재 장착된 리본종류 확인
	strMsg = "'리본종류'확인에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_chk_ribbon(objTP9100) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}	

	
	//이미지 버퍼 초기화하기
	strMsg = "'이미지 버퍼 초기화'에 실패했습니다.";
	
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_buffer_clear(objTP9100) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}	
	
	//텍스트를 비트맵으로 변환하기
    //   휴대폰번호
    var strMobile = objDS.GetColumn(0, "mobile");
    var strTel  = "TEL : ";
    var strText = "";
    
    if(length(strMobile) < 7) {
		strText   = "  "; //빈값이라도 있어야 인쇄시 Error가 발생하지 않는다.
    } else {
		strText   = strTel + strMobile;
    }
    	
	strMsg = "'비트맵 변환'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_text_to_Bmp(objTP9100, strText, 10) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}	

	//휴대폰번호 이미지 파일을 프린터의 이미지 버퍼로 전송
	strMsg = "'이미지 파일을 프린터의 이미지 버퍼로 전송'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	
	//  변환공식  1mm = (1/25.4 * 300) = 11.81102 픽셀
	if(gfn_adv_Image_SendEx(objTP9100, 170.91, 431.22) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}	
		
	// if(gfn_adv_Image_SendEx(objTP9100, 170.91, 442.22) != 0) {
		// gfn_adv_print_error(objTP9100, strMsg);
		// return;
	// }		 
			

	//   VIN
	strMsg = "'비트맵 변환'에 실패했습니다.";
	var strVin = objDS.GetColumn(0, "vin");   
	if(gfn_adv_text_to_Bmp(objTP9100, strVin, 7) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}	
			
	
	// VIN 이미지 파일을 프린터의 이미지 버퍼로 전송
	strMsg = "'이미지 파일을 프린터의 이미지 버퍼로 전송'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	//원본값 : 604.13   518.74 ->세부조정 후 아래값으로 변경
	if(gfn_adv_Image_SendEx(objTP9100, 596, 518.74) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}			
			
	
	//이미지 인쇄
	strMsg = "'인쇄'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_Image_PrintEx(objTP9100) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
	}		
	
	
	//카드 쓰기(마그네틱쓰기)
    var strMs_card_no    = objDS.GetColumn(0, "ms_card_no");
    var strseq           = lpad( objDS.GetColumn(0, "seq"), "0", 3);
    var strCust_no       = objDS.GetColumn(0, "cust_no");
    var strCust_div      = left(strCust_no, 1);
	
	strMsg = "'마그네틱쓰기'에 실패했습니다.";
	if(strPrintType == "new") strMsg += strCommMsg;
	
	if(gfn_adv_ms_write(objTP9100, strMs_card_no, strseq, strCust_no, strCust_div) != 0) {
		gfn_adv_print_error(objTP9100, strMsg);
		return;
		
	} else {
		//카드 배출
		strMsg = "'카드배출'에 실패했습니다.";

		if(gfn_adv_card_eject(objTP9100) != 0) {
			gfn_adv_print_error(objTP9100, strMsg);
			return;
		}	
	
	
		//장치 닫기
		strMsg = jv_closeError_msg;	
		if(gfn_adv_close_device(objTP9100) != 0) {
			alert(strMsg);
			return;
		}

		var strSuccessMsg  = "인쇄가 완료되었습니다.";
		
		if(strPrintType == "new") {
		    strSuccessMsg += "\n\n'멤버쉽카드 관리' 화면에서 내역을 확인할 수 있습니다.";
		}   
		    
		alert(strSuccessMsg);
	}	
	
}



//LCD 설정
function gfn_adv_LCD_Display(objTP9100, nMode, strData) {
	return objTP9100.axLCD_Display(nMode, strData);
}

//이미지 인쇄
function gfn_adv_Image_PrintEx(objTP9100) {
	return objTP9100.axImage_PrintEx(4, 0);
}


//현재 장착된 리본종류 확인
function gfn_adv_chk_ribbon(objTP9100) {
	return objTP9100.axCheckRibbon();
}


//텍스트를 비트맵으로 변환하기
function gfn_adv_text_to_Bmp(objTP9100, strText, nFontSize) {
	//trace("gfn_adv_text_to_Bmp  strText="+strText);
	//return objTP9100.axTextToBmpMakeEx("objTP9100.bmp", strText, "Arial", 49, 11, 300);
	
	//48 :일반, 49 :굵게  
	return objTP9100.axTextToBmpMakeEx("TP9100.bmp", strText, "HY견고딕", 49, nFontSize, 300);
}


//이미지 파일을 프린터의 이미지 버퍼로 전송
function gfn_adv_Image_SendEx(objTP9100, nXpos, nYpos) {
	//return objTP9100.axImage_SendEx( 180, 430, "TP9100.bmp", 109, 48, 0, 0, 255);
	return objTP9100.axImage_SendEx( nXpos, nYpos, "TP9100.bmp", 109, 48, 0, 0, 255);
}


//이미지 버퍼 초기화하기
function gfn_adv_buffer_clear(objTP9100) {
	return objTP9100.axImage_Buffer_Clear(11);
}


//장치 열기
function gfn_adv_open_device(objTP9100) {
	return objTP9100.axOpenDevice();
}

//장치 닫기
function gfn_adv_close_device(objTP9100) {
	return objTP9100.axCloseDevice();
}

//로그경로 설정
function gfn_adv_setLogPath(objTP9100) {
	return objTP9100.axSetLogPathFile("C:\\tp9xx.log");
}	

	
	
//카드 삽입	
function gfn_adv_card_insert(objTP9100) {
	return objTP9100.axCard_Insert();
}

//카드 배출
function gfn_adv_card_eject(objTP9100) {
	return objTP9100.axCard_Eject();
}

//카드 위치확인(0: 카드 없음, 1: 투입구에 있음, 2: 프린터 내부에 있음)
function gfn_adv_chk_feeder(objTP9100) {
	return objTP9100.axCheckFeeder();
}

//카드 읽기
function gfn_adv_ms_read(objTP9100) {
	return objTP9100.axMS_Read(2);
	
}

//카드 쓰기(마그네틱쓰기)
function gfn_adv_ms_write(objTP9100, strMs_card_no, strseq, strCust_no, strCust_div) {
    //고객번호를 마그네틱에 쓸 때 숫자만 가능하므로
    // P:0, C:1로 변환해서 처리한다. ISO2는 숫자(=;: 는 가능)37자 까지 가능
    // 트랙2:  숫자 37자 ( 카드번호 (21) + ’=‘ + 발급순번(3)  + ‘=‘ + 고객번호(10 단, P=0 / C=1 ) >> 총 36자
    //   예 : 006618291111111222222=001=0001837783 개인
    //   예 : 005619690002028145617=001=1000005231 법인
    if(strCust_div == "P") {
		strCust_no = replace(strCust_no, "P", "0");
		
    } else if(strCust_div == "C") {
		strCust_no = replace(strCust_no, "C", "1");
    }
    
	var strMagnetic_Text = strMs_card_no + "=" + strseq + "=" + strCust_no;	
	
	//var strMagnetic_Text = strMs_card_no;	
	//trace("gfn_adv_ms_write  strMagnetic_Text="+strMagnetic_Text);
	
	return objTP9100.axMS_Write( 2, "", strMagnetic_Text, "", 2 );
}

//인쇄중 Error 처리
function gfn_adv_print_error(objTP9100, strMsg) {
	//카드 배출
	gfn_adv_card_eject(objTP9100);
    
    //장치닫기
	gfn_adv_close_device(objTP9100);
	
	alert(strMsg);
}


//장치 검색, 열기(참고용 함수:TP9100이 PC에 2대 이상 연결시 사용)
function gfn_adv_TP91_init() {
	
	var nRtn = -1;
	var nDeviceCount = -1;
	var strDeviceString = "";

	nRtn = objTP9100.axListDevices(0, 255);
	
	nDeviceCount    = objTP9100.DeviceCount;
	strDeviceString = objTP9100.DeviceString;
	
	trace("nRtn="+nRtn);
	trace("nDeviceCount="+nDeviceCount);

	if(nRtn == 0 && nDeviceCount >0) {
		for(var i=0;  i<nDeviceCount; i++) {
			if( objTP9100.axListDevices(i, 2) == 0 ) {
				trace(i + " : " + objTP9100.DeviceString); //TITENG TP-9000이 리턴됨. TP-9100이 아님..
			}
			
		}
	}

}