﻿/*
   url call 관련 함수
   생성일 : 2020.06.01
   생성자 : 전양희
*/
var unreserved = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_.~";
var reserved = "!*'();:@&=+$,/?%#[]";
var allowed = unreserved + reserved;
var hexchars = "0123456789ABCDEFabcdef";
var decchars = "ABCDEF";

function convert16To10(str)
{
	var sum=0;
	
	str = toUpper(str);
	
	var s = midb(str,0,1);
	if ( s >= "A" && s <= "F" )
	{
		sum += (10+pos(decchars,s))*16;
	} else if ( s >= "0" && s <= "9" ){
		sum += (toNumber(s)*16);
	}

	s = midb(str,1,1);
	if ( s >= "A" && s <= "F" )
	{
		sum += (10+pos(decchars,s));
	} else if ( s >= "0" && s <= "9" ){
		sum += toNumber(s);
	}

	trace("convert : " + sum);
	return sum;
}

function gethex(decimal) 
{
  return "%" + charAt(hexchars,ext_getBitCalc(">>",decimal,4)) + 
               charAt(hexchars,ext_getBitCalc("&",decimal,15));
}

function getdec(hexencoded) 
{ 
   if (length(hexencoded) == 3) 
   { 
     if (charAt(hexencoded,0) == "%") { 
       if (indexOf(hexchars,charAt(hexencoded,1)) != -1 && indexOf(hexchars,charAt(hexencoded,2)) != -1) { 
         return convert16To10(midb(hexencoded,1,2)); 
       } 
     } 
   } 
   return 256; 
}

function urlEncodeUtf8(decoded) 
{
  // Some variables:
	var encoded = "";
	
	// ---------------- If UTF-8 character encoding was chosen: ----------------
	
	for (var i = 0; i < length(decoded); i++ ) 
	{
		var ch = charAt(decoded,i);
		// Check if character is an unreserved character:
		if (indexOf(unreserved,ch) != -1) {
			encoded = encoded + ch;
		} else {

			// The position in the Unicode table tells us how many bytes are needed.
			// Note that if we talk about first, second, etc. in the following, we are
			// counting from left to right:
			//
			//   Position in   |  Bytes needed   | Binary representation
			//  Unicode table  |   for UTF-8     |       of UTF-8
			// ----------------------------------------------------------
			//     0 -     127 |    1 byte       | 0XXX.XXXX
			//   128 -    2047 |    2 bytes      | 110X.XXXX 10XX.XXXX
			//  2048 -   65535 |    3 bytes      | 1110.XXXX 10XX.XXXX 10XX.XXXX
			// 65536 - 2097151 |    4 bytes      | 1111.0XXX 10XX.XXXX 10XX.XXXX 10XX.XXXX
	
			var charcode = Asc(charAt(decoded,i));
	
			// Position 0 - 127 is equal to percent-encoding with an ASCII character encoding:
			if (charcode < 128) {
			  encoded = encoded + gethex(charcode);
			}
	
			// Position 128 - 2047: two bytes for UTF-8 character encoding.
			if (charcode > 127 && charcode < 2048) {
			  // First UTF byte: Mask the first five bits of charcode with binary 110X.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc(">>",charcode,6),12));
			  // Second UTF byte: Get last six bits of charcode and mask them with binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",charcode,63),128));
			}
	
			// Position 2048 - 65535: three bytes for UTF-8 character encoding.
			if (charcode > 2047 && charcode < 65536) {
			  // First UTF byte: Mask the first four bits of charcode with binary 1110.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc(">>",charcode,12),224));
			  // Second UTF byte: Get the next six bits of charcode and mask them binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",ext_getBitCalc(">>",charcode,6),63),128));
			  // Third UTF byte: Get the last six bits of charcode and mask them binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",charcode,63),128));
			}
	
			// Position 65536 - : four bytes for UTF-8 character encoding.
			if (charcode > 65535) {
			  // First UTF byte: Mask the first three bits of charcode with binary 1111.0XXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc(">>",charcode,18),240));
			  // Second UTF byte: Get the next six bits of charcode and mask them binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",ext_getBitCalc(">>",charcode,12),63),128));
			  // Third UTF byte: Get the last six bits of charcode and mask them binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",ext_getBitCalc(">>",charcode,6),63),128));
			  // Fourth UTF byte: Get the last six bits of charcode and mask them binary 10XX.XXXX:
			  encoded = encoded + gethex(ext_getBitCalc("|",ext_getBitCalc("&",charcode,63),128));
			}
		}

	}  // end of for ...
	return encoded;
}



function urlDecodeUtf8(encoded)
{
	var notallowed = ""; 
	var illegalencoding = ""; 
    var decoded,allowed;
    
    var byte1, byte2, byte3, byte4; 
 
    var i = 0; 
    while (i < length(encoded)) { 
      var ch = charAt(encoded,i); 
      // Check for percent-encoded string: 
      if (ch == "%") { 
 
        // Check for legal percent-encoding of first byte: 
        if (getdec(mid(encoded,i,3)) < 255) { 
 
          // Get the decimal values of all (potential) UTF-bytes: 
          byte1 = getdec(mid(encoded,i,3)); 
          byte2 = getdec(mid(encoded,i+3,3)); 
          byte3 = getdec(mid(encoded,i+6,3)); 
          byte4 = getdec(mid(encoded,i+9,3)); 
 
          // Check for one byte UTF-8 character encoding: 
          if (byte1 < 128) { 
            decoded = decoded + chr(byte1);//String.fromCharCode(byte1); 
            i = i + 3; 
          } 
 
          // Check for illegal one byte UTF-8 character encoding: 
          if (byte1 > 127 && byte1 < 192) { 
            decoded = decoded + mid(encoded,i,3); 
            illegalencoding = illegalencoding + mid(encoded,i,3) + " "; 
            i = i + 3; 
          } 
 
          // Check for two byte UTF-8 character encoding: 
          if (byte1 > 191 && byte1 < 224) { 
            if (byte2 > 127 && byte2 < 192) { 
              //decoded = decoded + String.fromCharCode(((byte1 & 0x1F) << 6) | (byte2 & 0x3F));               
              decoded = decoded + chr(ext_getBitCalc("|",ext_getBitCalc("<<",ext_getBitCalc("&",byte1,31),6),ext_getBitCalc("&",byte2,63))); 
            } else { 
              decoded = decoded + mid(encoded,i,6); 
              illegalencoding = illegalencoding + mid(encoded,i,6) + " "; 
            } 
            i = i + 6; 
          } 
 
          // Check for three byte UTF-8 character encoding: 
          if (byte1 > 223 && byte1 < 240) { 
            if (byte2 > 127 && byte2 < 192) { 
              if (byte3 > 127 && byte3 < 192) { 
                decoded = decoded + chr(ext_getBitCalc("|",ext_getBitCalc("|",ext_getBitCalc("<<",ext_getBitCalc("&",byte1,15),12),ext_getBitCalc("<<",ext_getBitCalc("&",byte2,63),6)),ext_getBitCalc("&",byte3,63))); 
               // decoded = decoded + String.fromCharCode(((byte1 & 0xF) << 12) | ((byte2 & 0x3F) << 6) | (byte3 & 0x3F)); 
              } else { 
                decoded = decoded + mid(encoded,i,9); 
                illegalencoding = illegalencoding + mid(encoded,i,9) + " "; 
              } 
            } else { 
              decoded = decoded + mid(encoded,i,9); 
              illegalencoding = illegalencoding + mid(encoded,i,9) + " "; 
            } 
            i = i + 9; 
          } 
 
          // Check for four byte UTF-8 character encoding: 
          if (byte1 > 239) { 
            if (byte2 > 127 && byte2 < 192) { 
              if (byte3 > 127 && byte3 < 192) { 
                if (byte4 > 127 && byte4 < 192) { 
                  //decoded = decoded + String.fromCharCode(((byte1 & 0x7) << 18) | ((byte2 & 0x3F) << 12) | ((byte3 & 0x3F) << 6) | (byte4 & 0x3F)); 
				  decoded = decoded + chr(ext_getBitCalc("|",ext_getBitCalc("|",ext_getBitCalc("|",ext_getBitCalc("<<",ext_getBitCalc("&",byte1,7),18),ext_getBitCalc("<<",ext_getBitCalc("&",byte2,63),12)),ext_getBitCalc("<<",ext_getBitCalc("&",byte3,63),6)),ext_getBitCalc("&",byte4,63))); 
                } else { 
                  decoded = decoded + mid(encoded,i,12); 
                  illegalencoding = illegalencoding + mid(encoded,i,12) + " "; 
                } 
              } else { 
                decoded = decoded + mid(encoded,i,12); 
                illegalencoding = illegalencoding + mid(encoded,i,12) + " "; 
              } 
            } else { 
              decoded = decoded + mid(encoded,i,12); 
              illegalencoding = illegalencoding + mid(encoded,i,12) + " "; 
            } 
            i = i + 12; 
          } 
 
        } else {  // the first byte is not legally percent-encoded 
          decoded = decoded + mid(encoded,i,3); 
          illegalencoding = illegalencoding + mid(encoded,i,3) + " "; 
          i = i + 3; 
        } 
 
      } else {  // the string is not percent encoded 
        // Check if character is an allowed character: 
        if (indexOf(allowed,ch) == -1) notallowed = notallowed + ch + " "; 
        decoded = decoded + ch; 
        i++; 
      } 
    }  // end of while ..
    return decoded;
}
